%% Vesicles with l1=-2c_0+2c_0^2+l2, c0=-1; see cmdsm2plot.m for plotting, and 
% cmds0.m  for more comments on general procedure 
close all; keep pphome; 
global p2pglob; p2pglob.edc='k'; p2pglob.cut=0;  p2pglob.tsw=0; p2pglob.cb=1; p2pglob.axlab=1;
%% init 
al=1; sw=4; p=[]; c0=-1; A0=4*pi; V0=4*pi/3; 
l1=6-4*c0+2*c0^2; l2=6-2*c0; l1=l1-0.5;  
sx=0; sy=0; sz=0; srx=0; sry=0; srz=0;
par=[al; l1; l2; c0; A0; V0; sx; sy; sz; srx; sry; srz]; 
%                4           7           10
p=sphinit(p,par,sw); p=setfn(p,'m2'); p.tau=p.up; 
p.nc.mu1=5; p.nc.mu2=0.5; huclean(p); pplot(p);
%% BP1 on sphere 
p.fuha.qf=@qAV; p.fuha.qfder=@qAVder; p.fuha.sG=@sG2; p.nc.nq=5; p.sw.qjac=1; p.plot.bpcmp=15; 
p.w=[1 0 0]; p.om=[0 1 0]; p.rh=[0 0 1]; p.sw.Xcont=1;
p.sol.ds=1; p.nc.ilam=[2 3 6 7 8 9]; p.nc.nsteps=100; p=cont(p,5); 
%% BP2 from sphere
n=3; l1=n*(n+1)-4*c0+2*c0^2; l2=n*(n+1)-2*c0; l1=l1-0.5; p=loadp('m2','pt4');
p.u(p.nu+2)=l1; p.u(p.nu+3)=l2; p=cont(p,5);
%% BP1, oblate 
p=swibra('m2','bpt1','m2/o',0.1); mclf(2); p.nc.dsmax=0.05; p.nc.ilam=[6 2 3 7 8 9]; 
p.nc.tol=1e-3; p.sw.bifcheck=0; pause; p=cont(p,4); 
%% cont with 2 rot.PCs 
p=loadp('m2/o','pt4'); p=stan2rot(p,1e-8,-0.01,'min'); 
p.nc.Ab=1*max(doublearea(p.X,p.tri)); p.nc.errbound=10; p.nc.sigr=0.03; 
p.nc.sigc=0.05; p.nc.mu1=10;  p=cont(p,40); 
%% cont further with more degcoarsenX 
p=loadp('m2/o','pt40'); p.nc.errbound=6; p=cont(p,30); 
%% BP1, prolate 
p=swibra('m2','bpt1','m2/p',-0.05); p.nc.ilam=[6 2 3 7 8 9]; p.nc.tol=1e-3; p.nc.dsmax=0.05; 
p.sw.bifcheck=0; pause; p=cont(p,2); 
%% cont with 2 rot.PCs 
p=loadp('m2/p','pt2'); p=stan2rot(p,1e-8,-0.001,'max'); 
p.nc.Ab=1*max(doublearea(p.X,p.tri)); p.nc.dsmax=0.1; p.nc.errbound=10; 
p.nc.sigr=0.02; p.nc.sigc=0.05; p.nc.mu2=0.5; p=cont(p,60); toc
%% 1st from prolate 
p=swibra('m2/p','bpt1','m2/p-1',-0.02); p.nc.tol=1e-3; p.nc.errbound=10; 
p.nc.Ab=2*p.nc.Ab; p.nc.sigr=0.01; p.nc.sigc=0.01; p=cont(p,3); 
%% full rot PC  
p=loadp('m2/p-1','pt2','du'); p=stanfullrot(p,1e-6,-0.01); p.nc.sigc=0.075;
p.nc.dsmax=0.5; p.sw.bifcheck=0; p.nc.sigr=0.015; p=cont(p,25); 
%% 1st from oblate, stoma 
p=swibra('m2/o','bpt1','m2/o-1',0.2); p.nc.dsmax=0.05; p.nc.Ab=p.nc.Ab; 
p.nc.errbound=8; p.nc.sigc=0.05; p.nc.sigr=0.02; p.nc.tol=1e-8; p.sw.bifcheck=2; p=cont(p,70); 
%% Second BP with mult=7 all pitchforks by symmetry
aux=[]; aux.m=7; aux.besw=0; aux.soltol=1e-12; p0=cswibra('m2','bpt2',aux); 
%% Cone shape 
p=gentau(p0,[0 1 0 0 0 0 0],'m2/c',0.1); p.sw.bifcheck=0; p.nc.tol=1e-4; p=cont(p,4);
%% cont with 2 rots 
p=loadp('m2/c','pt6'); p=stan2rot(p,1e-6,-0.01,'max'); p.nc.dsmax=0.1; p=cont(p,46); 
%% Diamond without any rotational axis 
p=gentau(p0,[0 1 1 0 0 0],'m2/d',0.1); p.sw.bifcheck=0; p.nc.tol=1e-2; p=cont(p,4);
%% full rot 
p=loadp('m2/d','pt4'); p=stanfullrot(p,1e-8,-0.01); p.nc.sigr=0.01; p.nc.errbound=10; 
p.nc.dsmax=0.2; p.sw.bifcheck=2; p.nc.Ab=0.004; p.nc.foldtol=0.05; p=cont(p,26); 
%% 1'st from cone, D2
p=swibra('m2/c','bpt1','m2/c-1',0.2); p.nc.tol=1e-3; p.sw.bifcheck=0; p=cont(p,4); 
%% full rot 
p=loadp('m2/c-1','pt4'); p=stanfullrot(p,1e-8,-0.01); p.nc.sigr=0.01; p.nc.errbound=10; 
p.nc.Ab=0.01; p.nc.dsmax=0.2; p.sw.bifcheck=2; p.nc.foldtol=0.05; p=cont(p,16); 
%% 2nd from cone, D2 with Z2
p=swibra('m2/c','bpt2','m2/c-2',0.2); p.nc.tol=1e-3; p.sw.bifcheck=0; p=cont(p,4); 
%% full rot 
p=loadp('m2/c-2','pt4'); p=stanfullrot(p,1e-8,-0.01); p.nc.sigr=0.01; p.nc.errbound=10; 
p.nc.Ab=0.01; p.nc.dsmax=0.2; p.sw.bifcheck=2; p.nc.foldtol=0.05; p=cont(p,16); 
%%
p=swibra('m2/d','bpt2','m2/d-2',0.1);  p=cont(p,10); 
%% cont to strongly neg c0  
p=swiparf('m2/o','pt20','c0/o',[4,2,3,7,8,9,10,11]); 
p.sol.ds=-0.1; p=cont(p,10); 
%% stoma
p=swibra('c0/o','bpt1','c0/o-1',0.1); p=cont(p,10); 
