function [p,cstop]=refufu(p,brout,ds)
% mod of STANUFU with refinement (by area AND by triangle shape) and degcoarsen
p=ulamcheck(p); % test if a desired lambda value has been passed
brplot=brout(length(bradat(p))+p.plot.bpcmp); %y-axis value in bif-figure
fprintf('%4i %s %s %5.2e %4i  %s %s ', ...
    p.file.count,printcon(getlam(p)),printcon(brplot),p.sol.res,p.sol.iter, ...
    p.sol.meth,printcon(ds));
if(p.sw.errcheck>0) fprintf('%5.2e ',p.sol.err); end
if(p.sw.spcalc==1) fprintf(' %2i ', p.sol.ineg); end
npr=length(p.sw.bprint); 
for i=1:npr; fprintf('%s ',printcon(brout(length(bradat(p))+p.sw.bprint(i)))); end
fprintf('\n');
% put anything else here
Ai=doublearea(p.X,p.tri); Ai=sort(Ai/2,'descend');
if Ai(1)>p.nc.Ab; p.fuha.e2rs=@e2rsA; s=find(Ai>p.nc.Ab); % refine large area  triangles 
    try; sf=p.nc.sigfac; catch sf=1; end; sig=sf*length(s)/p.nt; 
  p=refineX(p,sig); p=retrigX(p); p.sol.xi=1/p.np; 
end
err=brout(6+21); % mesh-quality as error bound 
if err>p.nc.errbound; % degcoarsen-refine-retrig
    p.fuha.savefu(p); p.fuha.e2rs=@e2rsshape4; 
    nt=p.nt; p=degcoarsenX(p,p.nc.sigc,5); 
    if p.np>4500;  sig=nt/p.nt-1; sigr=sig/3; p=refineX(p,sigr); 
    else, p=refineX(p,p.nc.sigr); end;
    p=retrigX(p); p.sol.xi=1/p.np; 
    fprintf('\n');
end 
cstop=0; % further proceed as usual 
if(getlam(p)<p.nc.lammin)
    fprintf('  lam=%g < lammin=%g, stopping\n',getlam(p),p.nc.lammin); cstop=1;
end
if(getlam(p)>p.nc.lammax)
    fprintf('  lam=%g > lammax=%g, stopping\n',getlam(p),p.nc.lammax); cstop=1;
end