close all; keep pphome; 
%% stat. BD for vegOC, init, FSS branch 
close all; p=[]; lx=5; nx=18; ly=1.0*sqrt(3)*lx/2; sw=1; rho=0.03; nx=15; % faster 
ndim=2; p=veginit(p,lx,ly,nx,sw,rho,ndim); 
p=setfn(p,'2Df'); p0=p; screenlayout(p); % now find bif.points from FSS branch 
p.nc.ilam=8; p=setlam(p,23); p.sol.ds=-2; p.nc.nsteps=50; p.sw.bifcheck=2; p=cont(p,5); 
%%  delete pt-output in dir FSS generated by findbif, to keep dir small 
% and use cont to find the desired usrlam output points
delete('2Df/pt*.mat'); p=p0; p.sol.ds=-1; p.sw.bifcheck=0; p=cont(p,40); 
%% just compute kernel at first BP, then gentau 
aux=[]; aux.soltol=1e-10; aux.m=6; aux.besw=0; p0=cswibra('2Df','bpt1',aux); 
p0.sw.bifcheck=0; p0.sw.spcalc=0; p0.nc.dsmax=5; 
%%
p=gentau(p0,1,'hs'); p=cont(p,22); 
p=gentau(p0,[0 0 0 0 1],'vs'); p=cont(p,22); 
p=gentau(p0,[0 0 0 0 0 1],'hex'); p=cont(p,22); 
%% plot the BD, max v over R  
figure(3); clf; pcmp=1; 
plotbra('2Df',3,pcmp,'cl','k','lab',29); 
plotbra('vs',3,pcmp,'cl','b','lab',22,'lwst',2); 
plotbra('hs',3,pcmp,'cl',p2pc('o1'),'lab',20,'lwst',2); 
plotbra('hex','pt24',3,pcmp,'cl','r','lab',17, 'lwst',2) 
xlabel('R'); ylabel('max v'); axis([15 32 200 1000]); 
%% plot the BD, J_{ca} over R  
figure(3); clf; pcmp=4; 
plotbra('2Df',3,pcmp,'cl','k','lsw',0); 
plotbra('vs',3,pcmp,'cl','b','lab',22,'lwst',2); 
plotbra('hs',3,pcmp,'cl',p2pc('o1'),'lab',20,'lwst',2); 
plotbra('hex',3,pcmp,'cl','r','lab',17, 'lwst',2) 
xlabel('R'); ylabel('J_{ca}'); 
%% soln plots (pauses useful for exporting plots) 
load('vegcm.asc'); 
p=loadp('vs','pt22'); plotsol(p,1,1,2); yticks([-4 0 4]); colormap(vegcm); 
plotsol(p,2,5,2); yticks([-4 0 4]); colormap(hot); pause 
p=loadp('hs','pt20'); plotsol(p,1,1,2); yticks([-4 0 4]); colormap(vegcm); 
plotsol(p,2,5,2); yticks([-4 0 4]); colormap(hot); pause 
p=loadp('hex','pt17'); plotsol(p,1,1,2); yticks([-4 0 4]); colormap(vegcm); 
plotsol(p,2,5,2); yticks([-4 0 4]); colormap(hot); 

